﻿#include <stdio.h>
#include <vector>
#include <bitset>
using namespace std;

//In order to increase the size of a stack and to avoid its overflow 
//when using a "deep" recursion, you should use a special directive 
//(in the example, the size of the stack is set to be 16 MB):
#pragma comment(linker, "/STACK:16777216")

#define MAX 10005
int n, m, t, ans, currentComponentVertexesCount;

vector < vector <int> > p;
vector < int > topol;
bitset < MAX > vis;

void dfs(int from)
{
	//маркираме текущия връх за посетен
	vis[from] = true;

	//за всеки негов непосетен съсед
	for(int i = 0;i < p[from].size();i++)
		if(!vis[p[from][i]])
			dfs(p[from][i]);//стартираме обхождане в дълбочина 

	//увеличаваме броя на върховете, които са в текущия компонент
	currentComponentVertexesCount++;
}

void solve()
{
	for(int i = 0;i < n;i++)
	{
		if(!vis[i])//за всеки непосетен връх
		{
			currentComponentVertexesCount = 0; //зануляваме

			dfs(i);//стартираме обхождане в дълбочина 
			
			//актуализираме, ако сме намерили по-добро решение 
			if(currentComponentVertexesCount > ans)
				ans = currentComponentVertexesCount;
		}
	}
}

void init()
{
	p.clear();
	p.resize(n);
	topol.clear();
	vis.reset();
	ans = -1;
}

void read()
{
	int u, v;
	scanf("%d %d\n", &n, &m);

	init(); //зануляваме нужните структури и променливи

	for(int i = 0;i < m;i++)
	{
		scanf("%d%d", &u, &v);
		u--, v--;
		//графа е двойно-свързан
		p[u].push_back(v);//ребро от u към v 
		p[v].push_back(u);//ребро от v към u
	}
}

int main()
{
	scanf("%d\n", &t);
	while(t--)
	{
		read(); //изчитаме входните данни
		solve();//решаваме задачата
		printf("%d\n", ans);//извеждаме резултата
	}

	return 0;
}